SHARED CONST TRUE = 255
SHARED CONST FALSE = 0
SHARED CONST R0 = 2
SHARED CONST R0L = 2
SHARED CONST R0H = 3
SHARED CONST R1 = 4
SHARED CONST R1L = 4
SHARED CONST R1H = 5
SHARED CONST R2 = 6
SHARED CONST R2L = 6
SHARED CONST R2H = 7
SHARED CONST R3 = 8
SHARED CONST R3L = 8
SHARED CONST R3H = 9
SHARED CONST R4 = $0A
SHARED CONST R4L = $0A
SHARED CONST R4H = $0B
SHARED CONST R5 = $0C
SHARED CONST R5L = $0C
SHARED CONST R5H = $0D
SHARED CONST R6 = $0E
SHARED CONST R6L = $0F
SHARED CONST R7 = $10
SHARED CONST R7L = $10
SHARED CONST R7H = $11
SHARED CONST R8 = $12
SHARED CONST R8L = $12
SHARED CONST R8H = $13
SHARED CONST R9 = $14
SHARED CONST R9L = $14
SHARED CONST R9H = $15
SHARED CONST R10 = $16
SHARED CONST R10L = $16
SHARED CONST R10H = $17
SHARED CONST R11 = $18
SHARED CONST R11L = $18
SHARED CONST R11H = $19
SHARED CONST R12 = $1A
SHARED CONST R12L = $1A
SHARED CONST R12H = $1B
SHARED CONST R13 = $1C
SHARED CONST R13L = $1C
SHARED CONST R13H = $1D
SHARED CONST R14 = $1E
SHARED CONST R14L = $1E
SHARED CONST R14H = $1F
SHARED CONST R15 = $20
SHARED CONST R15L = $20
SHARED CONST R15H = $20 
SHARED CONST MACPTR = $FF44
SHARED CONST MCIOUT = $FEB1
SHARED CONST CHKIN = $FFC6
SHARED CONST CHKOUT = $FFC9
SHARED CONST CLRCHN = $FFCC
SHARED CONST CHROUT = $FFD2
SHARED CONST CHRIN = $FFCF
SHARED CONST READST = $FFB7
SHARED CONST RDTIM = $FFDE
SHARED CONST SETTIM = $FFDB
SHARED CONST LOADER = $FFD5
SHARED CONST SETNAM = $FFBD
SHARED CONST SETLFS = $FFBA
SHARED CONST MEM_COPY = $FEE7
SHARED CONST MEM_FILL = $FEE4
SHARED CONST VERA_CTRL = $9F25
SHARED CONST VERA_DATA0 = $9F23
SHARED CONST VERA_ADDR_LOW = $9F20
SHARED CONST VERA_ADDR_MID = $9F21
SHARED CONST VERA_ADDR_HI = $9F22
SHARED CONST XLIMIT = 319
SHARED CONST YLIMIT = 239
SHARED CONST FB_cursor_position = $FEFF
SHARED CONST FB_cursor_nextline = $FF02
SHARED CONST LAYER0_ON=16
SHARED CONST LAYER0_OFF=239
SHARED CONST LAYER1_ON=32
SHARED CONST LAYER1_OFF=223
SHARED CONST AUTO_INCREMENT = %00010000

DIM SHARED  VERA_DCVIDEO AS BYTE @$9F29


DIM SHARED L AS BYTE FAST
DIM SHARED I AS BYTE FAST
DIM SHARED J AS BYTE FAST
DIM SHARED C AS BYTE FAST
DIM SHARED Is_Host_FS AS BYTE
DIM SHARED ScratchBank AS BYTE
DIM SHARED I_Int AS INT
DIM CS AS STRING * 1
DIM SHARED FC AS STRING * 3
DIM SHARED FMSG AS STRING * 40
DIM SHARED E1 AS STRING * 2
DIM SHARED E2 AS STRING * 2
DIM SHARED _Key AS BYTE FAST
DIM SHARED _MX AS WORD @R14
DIM SHARED _MY AS WORD @R15
DIM SHARED _MWHEEL AS INT
DIM SHARED TMPStr AS STRING*96
DIM SHARED ERRMSG AS STRING*40



SUB HIDEGRAPHICS() STATIC SHARED
  VERA_DCVIDEO=VERA_DCVIDEO AND LAYER0_OFF
END SUB

SUB SHOWGRAPHICS() STATIC SHARED
  VERA_DCVIDEO= VERA_DCVIDEO OR LAYER0_ON
END SUB

SUB HIDETEXT() STATIC SHARED
 VERA_DCVIDEO=VERA_DCVIDEO AND LAYER1_OFF
END SUB

SUB SHOWTEXT() STATIC SHARED
  VERA_DCVIDEO=VERA_DCVIDEO OR LAYER1_ON
END SUB

SUB HIDEALL() STATIC SHARED
 CALL HIDEGRAPHICS()
 CALL HIDETEXT()
END SUB

SUB SHOWALL() STATIC SHARED
 CALL SHOWGRAPHICS()
 CALL SHOWTEXT()
END SUB


FUNCTION PET2ISO AS STRING*96(S AS STRING*96) STATIC SHARED
 TMPStr=""
 L=LEN(S)-1
 FOR I = 0 TO L
     C=ASC(MID$(S,I,1))
     IF C > 64 AND C < 91 THEN C=C+32
     IF C > 192 AND C < 219 THEN C=C-128
     TMPStr=TmpStr + CHR$(C)
 NEXT I
 RETURN TMPStr
END FUNCTION
 

FUNCTION SIGNED_BYTE AS INT(TByte AS BYTE) STATIC SHARED
  DIM TMPInt AS INT
  TMPInt = TByte
  IF TByte > 127 THEN TMPInt = TMPInt-256
  RETURN TMPInt
END FUNCTION

FUNCTION ASCII_UPPER AS STRING*96(TARGET AS STRING*96) STATIC SHARED
  TMPStr = ""
 L = LEN(TARGET)-1
 FOR I = 0 TO L
     C=ASC(MID$(TARGET,I,1))
     IF C > 96 AND C < 123 THEN C=C-32
     IF C > 192 AND C < 219 THEN C=C-128
     TMPStr=TmpStr + CHR$(C)
 NEXT I
 RETURN TMPStr
END FUNCTION

FUNCTION FILEEXISTS AS BYTE(FName AS STRING * 96,DEVICE AS BYTE) STATIC SHARED
  OPEN 2,DEVICE,2,FName + ",s,r"
  CLOSE 2
  OPEN 15,DEVICE,15
  INPUT #15, FC,FMSG,E1,E2
  CLOSE 15
  RETURN VAL(FC) < 20
END FUNCTION

SUB TEST_FILESYSTEM(PrintMSG AS BYTE) STATIC SHARED
  IF PrintMSG THEN PRINT "{WHITE}Testing File System{GREEN}:{LIGHT GREEN} ";
  TMPStr = "test.f"
  IF NOT FILEEXISTS(TMPStr,8) THEN
    OPEN 2,8,2,"@:"+TMPStr+",s,w"
    FOR I = 1 TO 60
      PRINT #2, "abcdefghijklmnopqrstuvwxyz"
      IF PrintMSG THEN PRINT ".";
    NEXT I
    CLOSE 2
  END IF
  OPEN 2,8,2,"test.f,s,r"
  ASM
   ldx {SCRATCHBANK}
   stx 0
   ldx #2
   jsr {CHKIN}
   ldx #0
   ldy #$A0
   lda #0
   clc
   jsr {MACPTR}
   sty {Is_Host_FS}
   jsr {CLRCHN}
  END ASM
  CLOSE 2
  If Is_Host_FS=1 THEN Is_Host_FS=$FF
  If Is_Host_FS=2 THEN Is_Host_FS=0
  If Is_Host_FS AND PrintMSG THEN PRINT "{YELLOW}HOST FILE SYSTEM{WHITE}" ELSE IF PrintMSG THEN PRINT "{LIGHT_RED}SD CARD FOUND{WHITE}"
END SUB

SUB ASCII_UPPER(strpointer AS WORD) OVERLOAD STATIC SHARED 
  FOR I = 1 TO PEEK(strpointer)
      L  = PEEK(strpointer + I)
      IF L > 96 AND L < 123 THEN L=L-32
      IF L > 192 AND L < 219 THEN L=L-128
      POKE strpointer + I,L
  NEXT I
END SUB

FUNCTION INSTR AS BYTE (haystack AS WORD, needle AS WORD) SHARED STATIC
  hlen = PEEK(haystack) : nlen = PEEK(needle)
  haystack = haystack + 1 : needle = needle + 1
  IF nlen > hlen THEN RETURN 255
  FOR i AS BYTE = 0 TO hlen - nlen
    FOR j AS BYTE = 0 TO nlen - 1
      IF PEEK(haystack + i + j) <> PEEK(needle + j) THEN EXIT FOR
    NEXT j
    IF j = nlen THEN RETURN i
  NEXT i
  RETURN 255
END FUNCTION

FUNCTION FILE_EXTENSION AS STRING * 10(Name AS STRING*96) STATIC SHARED
  DIM GotIt AS BYTE
  TMPStr = ""
  L=LEN(Name)-1
  GotIt = 0
  FOR I_Int = L TO 0 STEP -1
       CS = MID$(Name,CByte(I_Int),1)
       IF CS = "." THEN
         GotIt=$FF
         EXIT FOR
       END IF
       TMPStr = CS + TmpStr
  NEXT I_Int
  IF NOT GotIt THEN TmpStr = ""
  RETURN TmpStr
END FUNCTION

FUNCTION READTIM AS LONG() STATIC SHARED
 DIM TMP AS LONG
 ASM
   jsr {RDTIM}
   sta {TMP}
   stx {TMP}+1
   sty {TMP}+2
 END ASM
 RETURN TMP
END FUNCTION

SUB ZeroTimer() STATIC SHARED
  ASM
   lda #0
   tax
   tay
   jmp {SETTIM}
 END ASM
END SUB

SUB SLEEP(Jiffies AS LONG) STATIC SHARED
 CALL ZeroTimer()
 DO
 LOOP UNTIL (READTIM() = Jiffies)
END SUB

SUB RESET() STATIC SHARED
 ASM
  JMP ($FFFC)
 END ASM
END SUB








